package io.tswf.minecraft.blockventure.core.transmutation.transmute

import groovy.transform.CompileStatic
import io.tswf.transmutations.common.annotation.ClassReference
import io.tswf.transmutations.common.annotation.MethodDescription
import io.tswf.transmutations.transmute.annotation.AtMethodCall
import io.tswf.transmutations.transmute.annotation.LocalVariableValue
import io.tswf.transmutations.transmute.annotation.Transmute
import io.tswf.transmutations.transmute.injection.points.MethodCallInsnType
import io.tswf.transmutations.transmute.meta.MissingTargetStrategy
import net.minecraft.registry.DynamicRegistryManager
import net.minecraft.registry.Registry
import net.minecraft.registry.RegistryLoader
import net.minecraft.resource.ResourceManager

@CompileStatic
class TransmutationRegistryLoader {

    @Transmute(
            targetClass = @ClassReference(RegistryLoader),
            targetMethod = @MethodDescription(
                    name = "load",
                    returnType = @ClassReference(DynamicRegistryManager.Immutable),
                    parameterTypeClasses = [ ResourceManager, DynamicRegistryManager, List ]
            ),
            onMissing = MissingTargetStrategy.THROW
    )
    @AtMethodCall(
            callType = MethodCallInsnType.VIRTUAL,
            owner = @ClassReference(Registry),
            method = @MethodDescription(
                    name = "freeze",
                    parameterTypeClasses = [],
                    returnType = @ClassReference(ClassReference.VOID)
            )
    )
    static injectIntoDynamicRegistries(
            ResourceManager resourceManager,
            DynamicRegistryManager baseRegistryManager,
            List<RegistryLoader.Entry<?>> entries,

            @LocalVariableValue(index = 111, type = @ClassReference(Registry))
            Registry registry
    ) {

    }

}
